package main

import (
	"io"
	"os"
	"strings"
)

type rot13Reader struct {
	r io.Reader
}

func (rot13 rot13Reader) Read(b []byte) (int, error) {
	n, err := rot13.r.Read(b)
	if err != nil {
		return 0, nil
	}
	for i := 0; i < n; i++ {
		switch {
		case 'Z' >= b[i] && b[i] >= 'N' || 'z' >= b[i] && b[i] >= 'n':
			b[i] = b[i] - 13
		case 'N' > b[i] && b[i] >= 'A' || 'n' > b[i] && b[i] >= 'a':
			b[i] = b[i] + 13
		default:
		}
	}
	return n, err
}

func main() {
	s := strings.NewReader("Lbh penpxrq gur pbqr!")
	r := rot13Reader{s}
	io.Copy(os.Stdout, &r)
}
