package main

import (
	"fmt"
	"image"
	"image/color"

	"golang.org/x/tour/pic"
)

type Image struct{}

func (img Image) ColorModel() color.Model {
	return color.RGBAModel
}

func (img Image) Bounds() image.Rectangle {
	return image.Rect(0, 0, 100, 100)
}

func (img Image) At(a, b int) color.Color {
	return color.RGBA{uint8(a), uint8(b), uint8(a + b/2), 255}
}

func main() {
	fmt.Println(color.RGBAModel)
	m := Image{}
	pic.ShowImage(m)
}
