package main

import (
	"fmt"
	"math"
)

type ErrNegativeSqrt float64

func Sqrt(x float64) (float64, error) {
	// ^ 假如小于 0 直接返回
	if x < 0 {
		return x, ErrNegativeSqrt(x)
	}
	z := 1.0 // ^ 给定类型浮点数值
	for math.Abs(z*z-x) > 0.000001 {
		z -= (z*z - x) / (2 * z)
		fmt.Println(z)
	}
	return z, nil
}

// ^ ErrNegativeSqrt 实现了 error 接口
func (e ErrNegativeSqrt) Error() string {
	return fmt.Sprintf("cannot Sqrt negative number: %g", e)
}

func main() {
	fmt.Println(Sqrt(2))
	fmt.Println(Sqrt(-2))
}
